## acl2 8.3dfsg

=== books/projects/apply-model-2/Makefile ===
# Target "all" is the top target of Makefile-generic.  We avoid
# including Makefile-subdirs or Makefile-psubdirs because we want to
# be sure to control the order: first this directory, then
# subdirectories.

# At one time we had something like this:

# top: all
# 	$(MAKE) all-subdirs
# all-subdirs: ex1 ex2

# However, I (Matt K.) started seeing surprising (to me) dependency
# errors, perhaps due to some change in GNU Make around version 4.1.
# So now I take care to ensure that all books in the current directory
# are certified before certification is attempted in the
# subdirectories and, moreover, those subdirectories are done
# sequentially (to avoid the parallel recertification of
# e.g. apply-prim.lisp in the present directory on behalf of ex1/ and
# ex2/).

ACL2 ?= ../../../saved_acl2
ACL2_SYSTEM_BOOKS ?= ../..

.PHONY: top ex1 ex2 clean-subdirs clean-Makefile-tmp

top: Makefile-tmp
	$(MAKE) -f Makefile-tmp all ACL2_BOOKS_MAKEFILE=Makefile-tmp
	$(MAKE) ex1
	$(MAKE) ex2

Makefile-tmp : Makefile Makefile-deps
	@echo "Making $(PWD)/Makefile-tmp"
	cat Makefile Makefile-deps > Makefile-tmp

include $(ACL2_SYSTEM_BOOKS)/Makefile-generic

ex1:
	cd ex1 ; $(MAKE)

ex2:
	cd ex2 ; $(MAKE)

clean: clean-subdirs clean-Makefile-tmp

clean-Makefile-tmp:
	rm -f Makefile-tmp

clean-subdirs:
	cd ex1 ; $(MAKE) clean
	cd ex2 ; $(MAKE) clean

=== books/projects/smtlink/Makefile ===
# Copyright (C) 2015, University of British Columbia
# Written by Yan Peng (July 12th 2017)
#
# License: A 3-clause BSD license.
# See the LICENSE file distributed with ACL2
#

.PHONY: all clean

ACL2 ?= ../../../saved_acl2
ACL2_SYSTEM_BOOKS ?= ../..
ACL2_BUILD_DIR := ../../build

JOBS ?= 3

all: example

top:
	$(ACL2_BUILD_DIR)/cert.pl -j $(JOBS) -a $(ACL2) -b $(ACL2_SYSTEM_BOOKS) top

doc:
	$(ACL2_BUILD_DIR)/cert.pl -j $(JOBS) -a $(ACL2) -b $(ACL2_SYSTEM_BOOKS) doc

example:
	$(ACL2_BUILD_DIR)/cert.pl -j $(JOBS) -a $(ACL2) -b $(ACL2_SYSTEM_BOOKS) examples/examples.lisp examples/ringosc.lisp


clean:
	$(ACL2_BUILD_DIR)/clean.pl
	rm -rf manual

=== books/centaur/sv/failtest/Makefile ===
# SV - Symbolic Vector Hardware Analysis Framework
# Copyright (C) 2014-2015 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Jared Davis <jared@centtech.com>

.PHONY: all clean passing
all:


STARTJOB  ?= bash
COSIM_DIR := $(PWD)/../cosims
CORE      := $(COSIM_DIR)/cosim-core

SPEC_FILES := $(wildcard *.v)
TESTNAMES  := $(patsubst %.v, %, $(SPEC_FILES))
VOK_FILES  := $(patsubst %.v, %.vok,  $(SPEC_FILES))
SVOK_FILES := $(patsubst %.v, %.svok, $(SPEC_FILES))

FAILING_TEST_TARGETS := \
  bigwire1.svok \
  fn1.vok fn1.svok \
  gates2.svok \
  gates5.svok \
  iface8.svok \
  inc8.svok \
  inc9.svok \
  inst9.svok \
  inst12.svok \
  param9.svok \
  param10.svok \
  param11.svok \
  elab6.vok elab6.svok \
  stmt1.svok  \
  gen8b.vok gen8b.svok \
  iface26.svok \
  clocking2.svok \
  clocking3.svok \
  clocking4.svok \
  clocking5.svok \
  clocking6.svok \
  clocking9.svok

$(CORE):
	cd $(COSIM_DIR); $(MAKE) cosim-core
	ls -lah $(COSIM_DIR)/cosim-core

%.vok: %.v $(CORE)
	@echo "Making $*.vok"
	@rm -f $*.vok
	@ACL2_CUSTOMIZATION=NONE TESTNAME=$* EDITION=VERILOG-2005 \
          $(STARTJOB) -c "$(CORE) < run.lsp &> $*.vok.log"
	@ls -l $*.vok

%.svok: %.v $(CORE)
	@echo "Making $*.svok"
	@rm -f $*.svok
	@ACL2_CUSTOMIZATION=NONE TESTNAME=$* EDITION=SYSTEM-VERILOG-2012 \
          $(STARTJOB) -c "$(CORE) < run.lsp &> $*.svok.log"
	@ls -l $*.svok

all: $(VOK_FILES) $(SVOK_FILES)

PASSING_VOK := $(filter-out $(FAILING_TEST_TARGETS), $(VOK_FILES))
PASSING_SVOK := $(filter-out $(FAILING_TEST_TARGETS), $(SVOK_FILES))
passing: $(PASSING_VOK) $(PASSING_SVOK)

.phony: failing
failing: $(FAILING_TEST_TARGETS)

clean:
	rm -f *.vok *.svok *.log
	rm -rf csrc INCA_libs simv.daidir
	rm -f simv ucli.key *.history


# [Jared] hack so you can just write "make ansi1" or similar, adapted
# from vl linttests

.PHONY: $(TESTNAMES)

define mkTestTarget
$(1): $(1).vok $(1).svok
endef

$(foreach test, $(TESTNAMES), $(eval $(call mkTestTarget, $(test))))

=== books/kestrel/java/aij/Makefile ===
# Java Library
#
# Copyright (C) 2019 Kestrel Institute (http://www.kestrel.edu)
#
# License: A 3-clause BSD license. See the LICENSE file distributed with ACL2.
#
# Author: Alessandro Coglio (coglio@kestrel.edu)

################################################################################

# This file compiles the Java source files of AIJ without IntelliJ IDEA.
# It generates the class and jar files in the same places as IntelliJ IDEA does.

# This file also generates Javadoc HTML documentation
# for public, package-private, and private classes and members
# (not for protected classes and members
# because AIJ currently does not have any).
# The generated documentation goes into the directories
# javadoc-public, javadoc-package, and javadoc-private,
# from where it can be opened in a browser.

# This file also certifies the ACL2 files in this directory,
# which currently just consist of XDOC documentation for AIJ.
# Note that the ACL2 files do not depend on the Java-related files,
# and that the Java-related files do not depend on the ACL2 files.
# This file does not assume cert.pl and clean.pl to be in the path:
# it references them via a relative path from this directory.

# This file assumes that OpenJDK Java 13 is in the path,
# but it may well work with other Java versions or implementations.

################################################################################

$(info ) # print a blank line

all: aij javadoc-all acl2-files

aij: java/out/artifacts/AIJ_jar/AIJ.jar

java/out/artifacts/AIJ_jar/AIJ.jar: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate class files:"
	mkdir -p java/out/production/AIJ
	javac -d java/out/production/AIJ java/src/edu/kestrel/acl2/aij/*.java
	@echo ""
	@echo "Generate jar file:"
	mkdir -p java/out/artifacts/AIJ_jar
	jar cfm java/out/artifacts/AIJ_jar/AIJ.jar java/META-INF/MANIFEST.MF \
            -C java/out/production/AIJ/ .
	@echo ""

javadoc-all: javadoc-public javadoc-package javadoc-private

javadoc-public: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate public Javadoc documentation:"
	javadoc -d javadoc-public -public java/src/edu/kestrel/acl2/aij/*.java
	@echo ""

javadoc-package: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate package Javadoc documentation:"
	javadoc -d javadoc-package -package java/src/edu/kestrel/acl2/aij/*.java
	@echo ""

javadoc-private: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate private Javadoc documentation:"
	javadoc -d javadoc-private -private java/src/edu/kestrel/acl2/aij/*.java
	@echo ""

acl2-files: top.cert

top.cert: top.lisp
	@echo "Certify ACL2 files:"
	../../../build/cert.pl *.lisp
	@echo ""

clean:
	@echo "Delete class files and jar file:"
	/bin/rm -rf java/out
	@echo ""
	@echo "Delete Javadoc HTML files:"
	/bin/rm -rf javadoc-public
	/bin/rm -rf javadoc-package
	/bin/rm -rf javadoc-private
	@echo ""
	@echo "Delete ACL2 certification files:"
	../../../build/clean.pl
	@echo ""

=== books/projects/apply-model-2/ex1/Makefile ===
SHELL ?= $(shell which bash)

ACL2 ?= ../../../../saved_acl2

ACL2_SYSTEM_BOOKS ?= ../../..

include $(ACL2_SYSTEM_BOOKS)/Makefile-generic

clean: clean-more

.PHONY: clean-more
clean-more:
	rm -f evaluation-apply.lisp evaluation-user-defs.lisp Makefile-deps

REBUILD_MAKEFILE_DEPS := $(shell \
  rm -f Makefile-deps Makefile-deps.out && \
  (diff ../apply.lisp evaluation-apply.lisp 2>&1 > /dev/null || \
   cp -pf ../apply.lisp evaluation-apply.lisp) && \
  (diff user-defs.lisp evaluation-user-defs.lisp 2>&1 > /dev/null || \
   cp -pf user-defs.lisp evaluation-user-defs.lisp) && \
  $(ACL2_SYSTEM_BOOKS)/build/cert.pl --include-excludes -s Makefile-deps *.lisp)

include Makefile-deps

=== books/projects/rac/src/Makefile ===

all: ../bin/rac ../bin/parse

../bin/parse: parser.l parser.y parser.h output.c main.c
	bison -d -v parser.y
	flex parser.l
	g++ -g -o parse parser.tab.c lex.yy.c output.c main.c -ll
	install -m 775 parse ${RAC}/bin
	/bin/rm parse

../bin/rac: rac-skel
	echo "#!/bin/bash\n\nRAC=${RAC}\nACL2=${ACL2}" | cat - rac-skel > rac
	install -m 775 rac ${RAC}/bin
	/bin/rm rac

clean:
	/bin/rm -f rac parser.tab.c parser.tab.h parser.output lex.yy.c parser.c
	/bin/rm -f -r parse.dSym

veryclean: clean
	/bin/rm -f ../bin/rac ../bin/parse

=== books/projects/x86isa/tools/execution/examples/dataCopy/Makefile ===
# X86ISA Library
#
# Note: The license below is based on the template at:
# http://opensource.org/licenses/BSD-3-Clause
#
# Copyright (C) 2015, Regents of the University of Texas
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# o Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# o Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in the
#   documentation and/or other materials provided with the distribution.
#
# o Neither the name of the copyright holders nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Original Author(s):
# Shilpi Goel         <shigoel@cs.utexas.edu>


all:
	gcc -O1 -g -c core.c -o core.o
	gcc -o dataCopy.o dataCopy.c core.o

clean:
	rm -f *~
	rm -f *.o

run: all
	./dataCopy.o || /bin/true

=== books/workshops/2003/kaufmann/support/rtl/tool/Makefile ===
include ../../../../../../Makefile-generic
-include Makefile-deps

=== debian/changelog ===
acl2 (8.3dfsg-2) unstable; urgency=medium

  * certify-books -> regression-fresh
  * debhelper-compat ( = 13 )
  * standards 4.5.0
  * ISO-8859-16 -> UTF-8
  * watch version 4
  * lintian override: rfc2388.txt is not a license file
  * clean books/centaur/vl/kit/test.vlzip books/centaur/getopt/demo2 books/centaur/getopt/demo2-test.ok
  * remove w3 validation in home-page.html

 -- Camm Maguire <camm@debian.org>  Wed, 27 Jan 2021 14:05:42 +0000

acl2 (8.3dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Sat, 22 Aug 2020 14:29:22 +0000

=== debian/control ===
Source: acl2
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: debhelper-compat ( = 13 ), gcl ( >= 2.6.12-92), libgmp3-dev, libreadline-dev, emacs-gtk | emacsen, debhelper ( >= 5), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common, texinfo
Standards-Version: 4.5.0

Package: acl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: acl2-source, acl2-books
Suggests: acl2-emacs
Description: Computational Logic for Applicative Common Lisp: main binary
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the base ACL2 binary. 

Package: acl2-source
Architecture: all
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Depends: ${misc:Depends}	  
Description: Computational Logic for Applicative Common Lisp: source files
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the lisp source files to the main ACL2 binary.

Package: acl2-emacs
Architecture: all
Depends: acl2 (>= ${source:Version}), emacs-gtk | emacsen, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: emacs interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains an emacs interface to ACL2.

Package: acl2-infix
Architecture: any
Recommends: acl2-infix-source (= ${source:Version})
Depends: acl2 (= ${binary:Version}), texlive-latex-recommended, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains utilities and libraries to access ACL2 via an
 infix notation similar to that used in many non-lisp programming
 languages.

Package: acl2-infix-source
Architecture: all
Depends: ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix source
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the source files to the infix interface to
 ACL2.

Package: acl2-books
Architecture: any
Depends: acl2 (= ${binary:Version}), acl2-books-certs (= ${source:Version}), acl2-books-source (= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: compiled libraries
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains numerous precompiled and precertified libraries
 for use in proving theorems with ACL2.  Serious users will no doubt
 want to install this package.

Package: acl2-books-source
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library sources
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains source lisp files to the compiled libraries
 supplied in the ACL2-books package.

Package: acl2-books-certs
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library certificates
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This file contains certification records for the various precompiled
 libraries supplied in the ACL2-books package.  ACL2 essentially
 requires that all included books be certified before use.

Package: acl2-doc
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Architecture: all
Section: doc
Description: Computational Logic for Applicative Common Lisp: documentation
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the documentation for ACL2.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

# ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION:=500000000
# MAXJOBS:=$(shell gcl -batch -eval \
#    "(print \
#       (multiple-value-bind (a b c d) (si::heap-report) \
# 	(min 8 \
# 	     (ceiling (/ (- d c) (/ a 8)) \
#                       ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}))))")

NUMJOBS:=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
# NUMJOBS:=$(shell if test $(NUMJOBS) -gt ${MAXJOBS}; then echo ${MAXJOBS} ; else echo $(NUMJOBS); fi)

#books/workshops:
#	mkdir $@

#init.lsp.ori: 
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori 

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

debian/acl2-emacs.emacsen-startup: debian/acl2-emacs.emacsen-startup.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

#pgcl:
#	echo "(progn (setq compiler::*split-files* 100000)(si::save-system \"$@\"))" | GCL_ANSI=t gcl

saved_acl2: # pgcl #debian/patches_applied $(DLOPEN_T) 
#	gcl -batch -eval "(bye #-native-reloc 1)" || \
#		(gcl -batch -eval '(load "debian/dlopen.lisp")' && $(MAKE) do_saved)
#	gcl -batch -eval "(bye #+native-reloc 1)" || $(MAKE) GCL_ANSI=t LISP=gcl
	$(MAKE) GCL_ANSI=t LISP=gcl
	mv *$@.gcl $@

saved_acl2.c: saved_acl2
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q (in-package :acl2) " \
	      "#+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | HOME=$$(pwd) ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2
	HOME=$$(pwd) $(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2.c
	cp saved_acl2 saved_acl2.ori
	HOME=$$(pwd) $(MAKE) certify-books-short
	cp saved_acl2.ori saved_acl2

#	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \

debian/test.log: saved_acl2.c
	mv saved_acl2 saved_acl2.ori
	cp $< saved_acl2
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	GCL_MULTIPROCESS_MEMORY_POOL=t \
	$(MAKE) -j $(NUMJOBS) -l 2.95 regression-fresh 2>&1 | tee $@ & j=$$! ; \
	while sleep 1800; do echo Tick; done & k=$$! ; \
	wait $$j ; kill $$k
#	>$@ 2>&1 & j=$$! ; \
#	while sleep 1800; do echo Tick; done & k=$$! ; tail -f debian/test.log & l=$$! ; \
#	wait $$j ; kill $$k $$l
#	[ -f $@ ] && ! fgrep '**' $@ || (echo FULL TEST FAILS ;\
#		for i in $$(find books -name "*.out"); do \
#			if ! [ -e $${i%out}cert ] ; then \
#				echo $$i ; \
#				cat $$i ; \
#			fi ; \
		done)
	mv saved_acl2.ori saved_acl2
	[ -f $@ ] && ( ! fgrep '**' $@ || true ) 
	  # gcl -batch -eval \
          #   "(bye \
	  # 	  #-native-reloc 0 \
          #         #+native-reloc \
          #           (let ((w (multiple-value-bind (a b c d) (si::heap-report) (/ (- d c) (/ a 8))))) \
	  # 		 (format t \"certification run with ~s heap words~%\" w) \
	  # 		 (if (< w ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}) 0 1)))")

books/interface/infix/Makefile: books/interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2,1" $< > $@

infix-stamp: books/interface/infix/Makefile saved_acl2
	cd books/interface/infix && make -f Makefile compile 
	cd books/interface/infix && make -f Makefile example 
#	cd books/interface/infix && make -f Makefile events 
	touch $@

doc/TEX/acl2-book.ps.gz: saved_acl2
	HOME=$$(pwd) $(MAKE) DOC
	rm -f doc/HTML/LICENSE
	find doc -empty -exec rm {} \;

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp # doc/TEX/acl2-book.ps.gz
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: books/interface/infix/Makefile
	rm -f infix-stamp 
	cd books/interface/infix && make -f Makefile clean
	rm -f books/interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied: 
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-emacs acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

OVERRIDES:= $(shell find debian/ -name "*.lintian-overrides.in" |sed 's,\.in,,g')

clean: infix_clean #debian/patches_unapplied books/workshops
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	$(MAKE) clean-all
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f saved_acl2 init_nsaved1_acl2.lsp worklispext
	rm -f debian/mini-proveall.out books/short-test.log debian/test.log
#	! [ -e init.lsp.ori ] || mv init.lsp.ori init.lsp
	rm -f foo.lsp nsaved_acl2
	for i in data c h ; do \
		for j in $$(find -name "*.$$i") ; do\
			k=$$(echo $$j | sed "s,\.$$i$$,,1") ;\
			! [ -e $$k.lisp ] || rm $$j ; \
		done ; \
	done
	rm -f books/bdd/benchmarks.data acl2r.lisp tmp
	rm -f debian/dpatches $(INSTALLS) $(LINKS) debian/README.Debian saved_acl2*
	rm -f debian/dlopen.lisp debian/acl2-emacs.emacsen-startup
	rm -f debian/acl2.sh pgcl books/Makefile-tmp books/coi/gensym/gensym.out sys-proclaim.lisp
	rm -f books/coi/gensym/Makefile-deps books/coi/gensym/workxxx.gensym books/system/doc/rendered-doc.lsp
	rm -rf doc/HTML-old doc/EMACS-old doc/acl2-wc.txt books/std/io/test.sao
	rm -f books/centaur/bitops/bitsets-opt-raw.o books/centaur/vl/util/gc-raw.o \
		books/centaur/misc/tshell-raw.o books/centaur/vl/Makefile-tmp \
		books/build/Makefile-sources books/build/Makefile-certs 
	rm -f books/build/acl2-exports.certdep books/build/acl2-version.certdep \
		books/build/first-order-like-terms-and-out-arities.certdep \

=== debian/watch ===
version=4
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# Site		Directory		Pattern			Version	Script
#opts=pasv ftp://ftp.cs.utexas.edu/pub/moore/acl2/	acl2-([0-9.]*)\.tar\.gz	debian	uupdate
#opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/acl2-$1\.tar\.gz/ \
#  https://github.com/acl2-devel/acl2-devel/tags .*/v?(\d\S*)\.tar\.gz
opts=dversionmangle=s/dfsg\d*$// https://github.com/acl2-devel/acl2-devel/releases .*/acl2-v?(\d\S*)\.tar\.gz
